// -------------------------------------------------------------------------------
function Yahoo_Search() {}

Yahoo_Search.baseURL = function () {
  return "http://api.search.yahoo.com/WebSearchService/V1/";
}

Yahoo_Search.appid = function () {
  return "YahooSearchSidebar";
}

Yahoo_Search.baseArgs = function () {
  return "appid=" + this.appid();
}

Yahoo_Search.Results = function (args) {
  var xmlUrl = this.baseURL() + "webSearch?" 
       + this.baseArgs()
       + "&query=" + args["Doc"] 
       + "&zip=" 
       + "&start=" + args["First"] 
       + "&results=" + args["Count"];
  var xmlhttp = new XMLHttpRequest();
  xmlhttp.open("GET", xmlUrl, false);
  xmlhttp.send(null);
  return this.readXML(xmlhttp.responseXML);
}

Yahoo_Search.readXML = function (xmlDoc) {
  try {
    var retVal = new Array();
    var resultSet = xmlDoc.getElementsByTagName("ResultSet")[0];                                                              
    var totalResultsAvailable = parseInt(resultSet.getAttribute("totalResultsAvailable"));  
    var totalResultsReturned = parseInt(resultSet.getAttribute("totalResultsReturned"));                                      
    var firstResultPosition = parseInt(resultSet.getAttribute("firstResultPosition"));                                        
    var start = firstResultPosition;                                                                                          
    var end = firstResultPosition + totalResultsReturned - 1;                                                                 
                                                                                                                              
    var results = xmlDoc.getElementsByTagName("Result"); 
    for (var i = 0; i < results.length; i++) {                                                                                
      var result = results[i];                                                                                                
      var title = result.getElementsByTagName('Title')[0].firstChild.nodeValue;
      var summary = '';
      if (result.getElementsByTagName('Summary')[0].firstChild) {
        summary = result.getElementsByTagName('Summary')[0].firstChild.nodeValue;
      }
      var clickUrl = result.getElementsByTagName('ClickUrl')[0].firstChild.nodeValue;
      var url = result.getElementsByTagName('Url')[0].firstChild.nodeValue;
      retVal[i] = { I: start + i, Title: title, Summary: summary, ClickUrl: clickUrl, Url: url };
    }

    return retVal;
  } catch(exception) {
    alert('Exception occurred while reading XML (i=' + i + '; start=' + start + ';end=' + end + '): ' + exception);
  }
}
// -------------------------------------------------------------------------------

var lastQueryTerm;

function main() {
  if (0 && !document.getElementById("find-text").value) {
    newSearch();
  }
}

function focusTerms() {
  var obj = document.getElementById('find-text');
  obj.focus();
  obj.select();
}

function getPageNum() {
  return document.getElementById("page-num").value - 0;
}

function setPageNum(inPageNum) {
  document.getElementById("page-num").value = inPageNum;
}

function setNextAndPrevButtons() {
  var pageNum = getPageNum();
  var prevButtonState = (pageNum > 1);
  var nextButtonState = (pageNum < 10);
  document.getElementById("prev-btn").disabled = !prevButtonState;
  document.getElementById("next-btn").disabled = !nextButtonState;
}

function prevPage() {
  setPageNum(getPageNum() - 1);
  newSearch();
}

function nextPage() {
  setPageNum(getPageNum() + 1);
  newSearch();
}

function newSearch() {
  setNextAndPrevButtons();
  document.persist("find-text", "value");
  var queryTerm = document.getElementById("find-text").value;
  var pageNum = getPageNum();
  var first = (pageNum - 1) * 30 + 1;
  if (1 || queryTerm != lastQueryTerm) {
    var results = Yahoo_Search.Results({
           Doc:          queryTerm,
           // The following are optional.
           // Values shown are defaults.
           Mode:         "all",
           Count:        30,
           First:        first,
           Type:         "all",
           AllowAdult:   0,
           AllowSimilar: 0,
           Language:     "undef",
          });
    populateTree(results);
  }

  lastQueryTerm = queryTerm;
}

function populateTree(results) {      
    // need to clear currentIndex before clearing the tree to avoid an exception
    var tree = document.getElementById('result-tree');
    tree.currentIndex = 0;

    // remove all the existing data
    var el = document.getElementById("result-tree-children");
    while (el.hasChildNodes()) el.removeChild(el.lastChild);

    for (var i = 0; i < results.length; i++) {                                                                                
      var result = results[i];                                                                                                
      var index = result["I"];                                               
      var title = result["Title"];                                               
      title = title.split("\"").join("&quot;");                                                                               
      var summary = result["Summary"];
      summary = summary.split("'").join("\\&#39;");                                                                           
      summary = summary.split("\"").join("&quot;");                                                                           
      var clickUrl = result["ClickUrl"];
      var Url = result["Url"];

      var treeItem = document.createElement("treeitem");
      treeItem.setAttribute("clickUrl", clickUrl);
      treeItem.setAttribute("tooltip", summary);
      document.getElementById("result-tree-children").appendChild(treeItem);
      var treeRow = document.createElement("treerow");
      treeItem.appendChild(treeRow);
      var treeCell1 = document.createElement("treecell");
      treeCell1.setAttribute("label", index);
      treeRow.appendChild(treeCell1);
      var treeCell2 = document.createElement("treecell");
      treeCell2.setAttribute("label", title);
      treeRow.appendChild(treeCell2);
      var treeCell3 = document.createElement("treecell");
      treeCell3.setAttribute("label", summary);
      treeRow.appendChild(treeCell3);
      var treeCell4 = document.createElement("treecell");
      treeCell4.setAttribute("label", Url);
      treeRow.appendChild(treeCell4);
    }
}

function showSelected() {
  var tree = document.getElementById('result-tree');
  if (tree.currentIndex >= 0) {
    var treechildren = document.getElementById('result-tree-children');
    var item = treechildren.childNodes[tree.currentIndex];
    var clickUrl = item.getAttribute("clickUrl");
    top.content.window.location = clickUrl;
  }
}
